Index: /branches/ParallelEngine/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.EvolutionStrategy/3.3/EvolutionStrategyMainLoop.cs	(revision 5177)
@@ -274,8 +274,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (MutatorParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithmMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithmMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithmMainLoop.cs	(revision 5177)
@@ -219,8 +219,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (CrossoverParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithmMainLoop.cs	(revision 5177)
@@ -330,8 +330,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (CrossoverParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearchMainLoop.cs	(revision 5177)
@@ -246,8 +246,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (MoveGeneratorParameter.ActualValue == null || MoveEvaluatorParameter.ActualValue == null || MoveMakerParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithmMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithmMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithmMainLoop.cs	(revision 5177)
@@ -437,8 +437,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (CrossoverParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs	(revision 5177)
@@ -267,8 +267,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (CrossoverParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASAMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASAMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASAMainLoop.cs	(revision 5177)
@@ -447,8 +447,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (CrossoverParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealingMainLoop.cs	(revision 5177)
@@ -220,8 +220,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (MoveGeneratorParameter.ActualValue == null || MoveEvaluatorParameter.ActualValue == null || MoveMakerParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuListCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuListCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuListCreator.cs	(revision 5177)
@@ -55,5 +55,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IVariable var;
       CurrentScope.Variables.TryGetValue(TabuListParameter.ActualName, out var);
@@ -62,5 +62,5 @@
       else
         CurrentScope.Variables.Add(new Variable(TabuListParameter.ActualName, (IItem)TabuListParameter.ActualValue.Clone()));
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuNeighborhoodAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuNeighborhoodAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuNeighborhoodAnalyzer.cs	(revision 5177)
@@ -58,5 +58,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<BoolValue> tabu = IsTabuParameter.ActualValue;
       if (tabu.Length > 0) {
@@ -77,5 +77,5 @@
         }
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearchMainLoop.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearchMainLoop.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearchMainLoop.cs	(revision 5177)
@@ -295,9 +295,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (MoveGeneratorParameter.ActualValue == null || MoveEvaluatorParameter.ActualValue == null || MoveMakerParameter.ActualValue == null
         || TabuCheckerParameter.ActualValue == null || TabuMakerParameter.ActualValue == null)
         return null;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/AlleleFrequencyAnalysis/AlleleFrequencyAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/AlleleFrequencyAnalysis/AlleleFrequencyAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/AlleleFrequencyAnalysis/AlleleFrequencyAnalyzer.cs	(revision 5177)
@@ -88,5 +88,5 @@
     #endregion
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int updateInterval = UpdateIntervalParameter.Value.Value;
       IntValue updateCounter = UpdateCounterParameter.ActualValue;
@@ -238,5 +238,5 @@
           ((DoubleValue)results["Lost Alleles of Best Known Solution"].Value).Value = lostRelevantAllelesCount;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/BestScopeSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/BestScopeSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/BestScopeSolutionAnalyzer.cs	(revision 5177)
@@ -74,5 +74,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
@@ -85,5 +85,5 @@
       else i = qualities.Select((x, index) => new { index, x.Value }).OrderByDescending(x => x.Value).First().index;
       
-      IEnumerable<IScope> scopes = new IScope[] { ExecutionContext.Scope };
+      IEnumerable<IScope> scopes = new IScope[] { context.Scope };
       for (int j = 0; j < QualityParameter.Depth; j++)
         scopes = scopes.Select(x => (IEnumerable<IScope>)x.SubScopes).Aggregate((a, b) => a.Concat(b));
@@ -115,5 +115,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/DataVisualization/DataTableValuesCollector.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/DataVisualization/DataTableValuesCollector.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/DataVisualization/DataTableValuesCollector.cs	(revision 5177)
@@ -53,5 +53,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DataTable table = DataTableParameter.ActualValue;
       if (table == null) {
@@ -96,5 +96,5 @@
         }
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiAnalyzer.cs	(revision 5177)
@@ -66,5 +66,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IntValue interval = UpdateIntervalParameter.ActualValue;
       if (interval == null) interval = new IntValue(1);
@@ -80,9 +80,9 @@
         OperationCollection next = new OperationCollection();
         foreach (IndexedItem<IAnalyzer> item in Operators.CheckedItems)
-          next.Add(ExecutionContext.CreateOperation(item.Value));
-        next.Add(base.Apply());
+          next.Add(context.CreateOperation(item.Value));
+        next.Add(base.Apply(context));
         return next;
       } else {
-        return base.Apply();
+        return base.Apply(context);
       }
     }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/ParetoFrontAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/ParetoFrontAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/ParetoFrontAnalyzer.cs	(revision 5177)
@@ -26,12 +26,12 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleArray> qualities = QualitiesParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
-      Analyze(qualities, results);
-      return base.Apply();
+      Analyze(context, qualities, results);
+      return base.Apply(context);
     }
 
-    protected abstract void Analyze(ItemArray<DoubleArray> qualities, ResultCollection results);
+    protected abstract void Analyze(IExecutionContext context, ItemArray<DoubleArray> qualities, ResultCollection results);
   }
 }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/RankBasedParetoFrontAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/RankBasedParetoFrontAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/MultiObjective/RankBasedParetoFrontAnalyzer.cs	(revision 5177)
@@ -44,5 +44,5 @@
     }
 
-    protected override void Analyze(ItemArray<DoubleArray> qualities, ResultCollection results) {
+    protected override void Analyze(IExecutionContext context, ItemArray<DoubleArray> qualities, ResultCollection results) {
       ItemArray<IntValue> ranks = RankParameter.ActualValue;
 
@@ -61,5 +61,5 @@
             front[counter, k] = qualities[i][k];
           if (populationLevel) {
-            paretoArchive[counter] = (IScope)ExecutionContext.Scope.SubScopes[i].Clone();
+            paretoArchive[counter] = (IScope)context.Scope.SubScopes[i].Clone();
           }
           counter++;
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/PopulationDiversityAnalysis/PopulationDiversityAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/PopulationDiversityAnalysis/PopulationDiversityAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/PopulationDiversityAnalysis/PopulationDiversityAnalyzer.cs	(revision 5177)
@@ -73,5 +73,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int updateInterval = UpdateIntervalParameter.Value.Value;
       IntValue updateCounter = UpdateCounterParameter.ActualValue;
@@ -230,5 +230,5 @@
         }
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestAverageWorstQualityCalculator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestAverageWorstQualityCalculator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestAverageWorstQualityCalculator.cs	(revision 5177)
@@ -68,5 +68,5 @@
 
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
       bool maximization = MaximizationParameter.ActualValue.Value;
@@ -95,5 +95,5 @@
         else worst.Value = min;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestQualityMemorizer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestQualityMemorizer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/BestQualityMemorizer.cs	(revision 5177)
@@ -59,5 +59,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
       bool maximization = MaximizationParameter.ActualValue.Value;
@@ -70,5 +70,5 @@
       if (best == null) BestQualityParameter.ActualValue = new DoubleValue(max);
       else best.Value = max;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDifferenceCalculator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDifferenceCalculator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityDifferenceCalculator.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleValue first = FirstQualityParameter.ActualValue;
       DoubleValue second = SecondQualityParameter.ActualValue;
@@ -76,5 +76,5 @@
         else RelativeDifferenceParameter.ActualValue.Value = relative;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Analysis/3.3/ValueAnalysis/MinAverageMaxValueCalculator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Analysis/3.3/ValueAnalysis/MinAverageMaxValueCalculator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Analysis/3.3/ValueAnalysis/MinAverageMaxValueCalculator.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<DoubleValue> values = ValueParameter.ActualValue;
 
@@ -84,5 +84,5 @@
         else maxValue.Value = max;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Core/3.3/Interfaces/IOperator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 5177)
@@ -23,32 +23,11 @@
 
 namespace HeuristicLab.Core {
-  /// <summary>
-  /// Interface to represent an operator (e.g. GreaterThanComparator,...), 
-  /// a basic instruction of an algorithm.
-  /// </summary>
   public interface IOperator : IParameterizedNamedItem {
-    /// <summary>
-    /// Gets or sets a boolean value whether the engine should stop here during the run.
-    /// </summary>
     bool Breakpoint { get; set; }
 
-    /// <summary>
-    /// Executes the current instance on the specified <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope where to execute the current instance.</param>
-    /// <returns>The next operation.</returns>
     IOperation Execute(IExecutionContext context);
-    /// <summary>
-    /// Aborts the current operator.
-    /// </summary>
     void Abort();
 
-    /// <summary>
-    /// Occurs when the breakpoint flag of the current instance was changed.
-    /// </summary>
     event EventHandler BreakpointChanged; 
-    /// <summary>
-    /// Occurs when the current instance is executed.
-    /// </summary>
     event EventHandler Executed;
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCreator.cs	(revision 5177)
@@ -58,7 +58,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       BinaryVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorCrossover.cs	(revision 5177)
@@ -59,7 +59,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVectorManipulator.cs	(revision 5177)
@@ -53,7 +53,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       Manipulate(RandomParameter.ActualValue, BinaryVectorParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Crossovers/MultiBinaryVectorCrossover.cs	(revision 5177)
@@ -90,7 +90,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one binary vector crossover to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveGenerator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveGenerator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveGenerator.cs	(revision 5177)
@@ -54,5 +54,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       BinaryVector v = BinaryVectorParameter.ActualValue;
       OneBitflipMove[] moves = GenerateMoves(v);
@@ -63,5 +63,5 @@
       }
       CurrentScopeParameter.ActualValue.SubScopes.AddRange(moveScopes);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveMaker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveMaker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveMaker.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       OneBitflipMove move = OneBitflipMoveParameter.ActualValue;
       BinaryVector binaryVector = BinaryVectorParameter.ActualValue;
@@ -73,5 +73,5 @@
       quality.Value = moveQuality.Value;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveTabuChecker.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveTabuChecker.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Moves/OneBitflipMove/OneBitflipMoveTabuChecker.cs	(revision 5177)
@@ -80,5 +80,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemList<IItem> tabuList = TabuListParameter.ActualValue;
       OneBitflipMove move = OneBitflipMoveParameter.ActualValue;
@@ -101,5 +101,5 @@
       }
       MoveTabuParameter.ActualValue = new BoolValue(isTabu);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Crossovers/MultiIntegerVectorCrossover.cs	(revision 5177)
@@ -90,7 +90,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one integer vector crossover to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCreator.cs	(revision 5177)
@@ -66,7 +66,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       IntegerVectorParameter.ActualValue = Create(RandomParameter.ActualValue, LengthParameter.ActualValue, MinimumParameter.ActualValue, MaximumParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorCrossover.cs	(revision 5177)
@@ -59,7 +59,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVectorManipulator.cs	(revision 5177)
@@ -53,7 +53,7 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       Manipulate(RandomParameter.ActualValue, IntegerVectorParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Creators/RandomPermutationCreator.cs	(revision 5177)
@@ -72,7 +72,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       PermutationParameter.ActualValue = new Permutation(PermutationType, LengthParameter.ActualValue.Value, RandomParameter.ActualValue);
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Crossovers/MultiPermutationCrossover.cs	(revision 5177)
@@ -90,7 +90,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one permutation crossover to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Encodings.PermutationEncoding/3.3/Manipulators/MultiPermutationManipulator.cs	(revision 5177)
@@ -82,7 +82,7 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one permutation manipulator to choose from.");
-      return base.Apply();
+      return base.Apply(context);
     }
   }
